Index: /trunk/src/Makefile.am
===================================================================
--- /trunk/src/Makefile.am	(revision 7427)
+++ /trunk/src/Makefile.am	(revision 7428)
@@ -29,4 +29,5 @@
 		$(WorldEntities_SOURCES_) \
 		$(StoryEntities_SOURCES_) \
+		lib/shell/some_shell_commands.cc \
 		orxonox.cc \
 		\
Index: /trunk/src/lib/coord/p_node.cc
===================================================================
--- /trunk/src/lib/coord/p_node.cc	(revision 7427)
+++ /trunk/src/lib/coord/p_node.cc	(revision 7428)
@@ -29,7 +29,4 @@
 
 #include "synchronizeable.h"
-
-#include "shell_command.h"
-SHELL_COMMAND(debugNode, PNode, debugNodeSC);
 
 using namespace std;
Index: /trunk/src/lib/graphics/graphics_engine.cc
===================================================================
--- /trunk/src/lib/graphics/graphics_engine.cc	(revision 7427)
+++ /trunk/src/lib/graphics/graphics_engine.cc	(revision 7428)
@@ -571,10 +571,4 @@
   //  LightManager::getInstance()->draw();
 
-  GraphicsEngine::storeMatrices();
-  Shader::suspendShader();
-
-  Render2D::getInstance()->draw(E2D_LAYER_ALL);
-  Shader::restoreShader();
-
   if (this->graphicsEffects != NULL)
   {
@@ -584,4 +578,9 @@
       dynamic_cast<GraphicsEffect*>(*it)->draw();
   }
+  GraphicsEngine::storeMatrices();
+  Shader::suspendShader();
+
+  Render2D::getInstance()->draw(E2D_LAYER_ALL);
+  Shader::restoreShader();
 }
 
Index: /trunk/src/lib/graphics/text_engine/font.cc
===================================================================
--- /trunk/src/lib/graphics/text_engine/font.cc	(revision 7427)
+++ /trunk/src/lib/graphics/text_engine/font.cc	(revision 7428)
@@ -29,5 +29,4 @@
 #include "stdlibincl.h"
 #include "compiler.h"
-
 using namespace std;
 
Index: /trunk/src/lib/graphics/text_engine/font.h
===================================================================
--- /trunk/src/lib/graphics/text_engine/font.h	(revision 7427)
+++ /trunk/src/lib/graphics/text_engine/font.h	(revision 7428)
@@ -74,5 +74,4 @@
     inline TTF_Font* getTTF() const { return this->fontTTF; };
 
-
     /** @returns the default Font */
     inline static Font* getDefaultFont() { if (Font::defaultFont == NULL) initDefaultFont(); return Font::defaultFont; };
Index: /trunk/src/lib/graphics/text_engine/text_engine.cc
===================================================================
--- /trunk/src/lib/graphics/text_engine/text_engine.cc	(revision 7427)
+++ /trunk/src/lib/graphics/text_engine/text_engine.cc	(revision 7428)
@@ -37,5 +37,4 @@
 
 #include "debug.h"
-
 ///////////////////
 /// TEXT-ENGINE ///
@@ -104,5 +103,5 @@
 /**
  *  function to disable TTF_fonts
-*/
+ */
 void TextEngine::disableFonts()
 {
Index: /trunk/src/lib/lang/class_list.cc
===================================================================
--- /trunk/src/lib/lang/class_list.cc	(revision 7427)
+++ /trunk/src/lib/lang/class_list.cc	(revision 7428)
@@ -22,15 +22,7 @@
 #include "debug.h"
 #include <string.h>
-#include <math.h>
+#include <cmath>
 #include <algorithm>
-#include "shell_command.h"
-
 using namespace std;
-
-#ifndef NO_SHELL_COMMAND
-SHELL_COMMAND_STATIC(debug, ClassList, ClassList::debugS)
-    ->describe("Shows all registered classes, if param1: is a valid ClassName only values of this class are shown. param2: how much output")
-    ->defaultValues(MT_NULL, 1);
-#endif
 
 /**
@@ -353,5 +345,5 @@
     {
       lenCount = 1;
-      while (pow(10, lenCount) <= (*cl).objectList.size())
+      while (std::pow((float)10, (int)lenCount) <= (*cl).objectList.size())
         ++lenCount;
       for (int i=0; i < 30-(*cl).className.size() - lenCount; i++)
Index: /trunk/src/lib/shell/Makefile.am
===================================================================
--- /trunk/src/lib/shell/Makefile.am	(revision 7427)
+++ /trunk/src/lib/shell/Makefile.am	(revision 7428)
@@ -22,2 +22,4 @@
 		shell_completion.h \
 		shell_completion_plugin.h
+
+EXTRA_DIST = some_shell_commands.cc
Index: /trunk/src/lib/shell/some_shell_commands.cc
===================================================================
--- /trunk/src/lib/shell/some_shell_commands.cc	(revision 7428)
+++ /trunk/src/lib/shell/some_shell_commands.cc	(revision 7428)
@@ -0,0 +1,42 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Benjamin Grauer
+   co-programmer: ...
+*/
+
+/*!
+ * @file some_shell_commands.cc
+ * @brief All the ShellCommands, that should not pollute the SourceCode.
+ */
+
+//#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_
+
+#include "shell/shell_command.h"
+using namespace OrxShell;
+
+
+
+#include "class_list.h"
+  SHELL_COMMAND_STATIC(debug, ClassList, ClassList::debugS)
+      ->describe("Shows all registered classes, if param1: is a valid ClassName only values of this class are shown. param2: how much output")
+      ->defaultValues(MT_NULL, 1);
+
+#include "p_node.h"
+  SHELL_COMMAND(debugNode, PNode, debugNodeSC);
+  SHELL_COMMAND(setPosition, PNode, setAbsCoor);
+
+
+#include "material.h"
+  SHELL_COMMAND(setDiffuseTexture, Material, setDiffuseMap)
+      ->defaultValues(MT_NULL, (int)GL_TEXTURE_2D)
+      ->completionPlugin(0, CompletorFileSystem());
+
